/* This program tries different constructions used in the Monte-Carlo and
   related program package
*/

#include <stdio.h>                  
#include <math.h>                   
/*     #include <stdlib.h> 
#include <string.h>
#include <ctype.h>
#include <time.h>

#include <curses.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/times.h>
#include <sys/time.h>       */
#include <values.h>

#ifndef ultrix
/*      fseek() values  */
#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2
#define CLOCKS_PER_SEC 1000000
#endif

#define PE         (void)fprintf(stderr,
#define PR         (void)fprintf(stdout,
#define N    3
#define N1   (N + 1)

int MAXBASE = 20;
extern char *DateAndTime();
FILE *Listing = stdout;

extern unsigned short ss1[3], ss2[3];
			 /* storage space and seeds for erand48() */
extern void exit();


main()
/*==*/
{
FILE *f = stdout, *fopen(), *ff;
static double a[N] = { 1100000000012.35, 23.45, 12345678e+300},
	      d[N1] = {1.,2.,3.,4.};
unsigned short us;
unsigned int u;
short l;
int i, k;
double b, *x;
/*static char c[3] = {'a'};*/
static char c[3];
long j, o = -24L, offset, o1, o2;

double U = 23.;

long int ij = 1802, kl = 9373;
extern int rmarin1();
extern double ranmar1(), erand48(), halton();
extern void init_halton(), reset_halton();
double x1, x2;
/*
#ifdef ultrix
   extern void srand();
#else
   extern int srand();
#endif
long random();
*/
double maxint = 2147483648., maxrand;
char *setstate(), *initstate(), state[256], state1[256], *ip1, *ip2;
static unsigned short int ss1[3] = {1745,719,3}, ss2[3] = {75,813,47345};

int i0,i1,i2,i3,i4,i5,i6;
char *string = "(12,234,-34,12)(12,77)";
/* --------------------------  End of declarations ------------------------- */

#ifdef RAND_MAX
maxrand = RAND_MAX + 1.;
#else
maxrand = maxint;
#endif

PE"Miscellaneous (incl mixed write)/random numbers/read-write? (m/r/w)\n");
scanf("%s",c);
if(c[0] == 'r' || c[0] == 'R') goto TESTb;
if(c[0] == 'w' || c[0] == 'W') goto TESTc;

PR"\nBITSPERBYTE = %u\nHIBITL = %lu, MAXLONG = %lu\n",
 BITSPERBYTE, HIBITL, MAXLONG);
PR"HIBITI = %u, MAXINT = %u\n", HIBITI, MAXINT);
PR"(1 << BITS(short) - 1) = %lu\n", (1 << BITS(short) - 1));
PR"HIBITS = %lu, %hu, MAXSHORT = %hu\n", HIBITS, (short)HIBITS, MAXSHORT);
PR"BITS(long) = %u, BITS(int) = %u, BITS(short) = %u\n",
BITS(long), BITS(int), BITS(short));
/*exit(0);*/

i = (1 << 31);
PR"\n%d %u\n", i, i);
i -= 1;
PR"%d\n", i);
u = ~1 | 1;
PR"%u\n", u);
us = ~1 | 1;
PR"%u\n\n", us);
us = 1;
k = sizeof(short) * 8;
for(i = 0; i <= k; i++) { us <<= 1; us |= 1; PR"%d %u\n", i, us); }
PR"\n");

us = 4569234;
PR"4569234: %u\n",us);
us = (short)4569234;
PR"(short)4569234: %u\n",us);
#ifdef ultrix
us = 4569234u;
#else
us = 4569234;
#endif
PR"4569234u: %u\n",us);
us = (unsigned short)4569234;
PR"(unsigned short)4569234: %u\n",us);
PR"\n");

u = 456923433445566;
PR"456923433445566: %u\n",u);
#ifdef ultrix
u = 456923433445566u;
#else
us = 456923433445566;
#endif
PR"456923433445566u: %u\n",u);
u = (unsigned int)456923433445566;
PR"(unsigned int)456923433445566: %u\n",u);
PR"\n");

/* exit(0); */

i0 = sscanf(string,"(%d,%d,%d,%d)(%d,%d)", &i1,&i2,&i3,&i4,&i5,&i6);
PR"%d %d %d %d %d %d %d\n",i0,i1,i2,i3,i4,i5,i6);
string = "(742,2234,-2 333)";
i0 = sscanf(string,"(%d,%d,%d,%d)(%d,%d)", &i1,&i2,&i3,&i4,&i5,&i6);
PR"%d %d %d %d %d %d %d\n",i0,i1,i2,i3,i4,i5,i6);
string = "(712,34)";
i0 = sscanf(string,"(%d,%d,%d,%d)(%d,%d)", &i1,&i2,&i3,&i4,&i5,&i6);
PR"%d %d %d %d %d %d %d\n",i0,i1,i2,i3,i4,i5,i6);
string = "()()";
i0 = sscanf(string,"(%d,%d,%d,%d)(%d,%d)", &i1,&i2,&i3,&i4,&i5,&i6);
PR"%d %d %d %d %d %d %d\n",i0,i1,i2,i3,i4,i5,i6);
PR"\n");

goto TESTa;


TESTb:
 PR"\n");

/* randon-number generator testing ----------------------------- >  */

/*k = 0; for(i = 0; i < 4; i++) PR"%d\n", i % k); exit();*/

#ifdef ultrix
 /*
 srand(73121u);
 for(i = 0; i < 5; i++)  { PR"%d\n", k = rand()); srand((unsigned)k); }
 PR"\n");
 */
 PR"rand(73121):\n");
 srand(73121u);
 for(i = 0; i < 12; i++)  PR"%.20g\n", rand() / maxrand);
 PR"\n");
 PR"rand(21):\n");
 srand(21u);
 for(i = 0; i < 12; i++)  PR"%.20g\n", rand() / maxrand);
 PR"\n");
 /*
 srand((unsigned)k);
 for(i = 0; i < 5; i++)  PR"%d\n", rand());
 exit(0);
 */
#else
 /*
 srand(73121);
 for(i = 0; i < 5; i++)  { PR"%d\n", k = rand()); srand(k); }
 PR"\n");
 */
 PR"rand(73121):\n");
 srand(73121);
 for(i = 0; i < 12; i++)  PR"%.20g\n", rand() / maxrand);
 PR"\n");
 PR"rand(21):\n");
 srand(21);
 for(i = 0; i < 12; i++)  PR"%.20g\n", rand() / maxrand);
 PR"\n");
 /*
 srand(k);
 for(i = 0; i < 5; i++)  PR"%d\n", rand());
 exit(0);
 */
#endif

PR"random(73121,256):\n");
initstate(73121, state1, 256);
for(i = 0; i < 12; i++) PR"%.20g\n", random() / maxint);
PR"\n");
PR"random(3,256):\n");
initstate(3, state1, 256);
for(i = 0; i < 12; i++) PR"%.20g\n", random() / maxint);
PR"\n");
/*
/*exit(0);*/

#ifdef ultrix
ip1 = initstate(73121u, state, 256);
ip2 = initstate(1u, state1, 256);
#else
ip1 = initstate(73121, state, 256);
ip2 = initstate(1, state1, 256);
#endif
setstate(state1);
for(i = 0; i < 5; i++) PR"%d\n", random());
/*exit(0);*/
PR"\n");
setstate(state);
for(i = 0; i < 5; i++) PR"%d\n", random());
PR"\n");
setstate(ip1);
for(i = 0; i < 5; i++) PR"%d\n", random());
PR"\n");
setstate(ip2);
for(i = 0; i < 5; i++) PR"%d\n", random());
PR"\n");
setstate(state1);
for(i = 0; i < 5; i++) PR"%d\n", random());
PR"\n");
/*exit(0);*/

#ifdef ultrix
srand(73121u);
#else
srand(73121);
#endif
/*for(i = 0; i < 1000; i++)*/
for(i = 0; i < 10; i++)
  PR"%.12g %.12g\n", (double) rand() / maxrand, (double) rand() / maxrand);
/*exit(0);*/


PR"erand48(ss1), erand48(ss2):\n");
for(i = 0; i < 12; i++)
	 { x1 = erand48(ss1);
	   x2 = erand48(ss2);
	   PR"%.20g %.20g %d %d %d %d %d %d\n",
		 x1, x2, ss1[0], ss1[1], ss1[2], ss2[0], ss2[1], ss2[2]);
	 }
PR"\n");

PR"halton(4)(2,3,5,7)\n");
init_halton(2);
init_halton(3);
init_halton(5);
init_halton(7);
for(i = 0; i < 12; i++) PR"%.20g\n", halton());
PR"\n");
reset_halton();

PR"halton(1)(3)\n");
init_halton(3);
for(i = 0; i < 12; i++) PR"%.20g\n", halton());
PR"\n");
reset_halton();

PR"halton(4)(3,7,8,13)\n");
init_halton(3);
init_halton(7);
init_halton(8);
init_halton(13);
for(i = 0; i < 12; i++) PR"%.20g\n", halton());
PR"\n");
reset_halton();

PR"halton(2)(5,7)\n");
init_halton(5);
init_halton(7);
for(i = 0; i < 12; i++) PR"%.20g\n", halton());
PR"\n");
reset_halton();
/*
for(i = 0; i < 10000000; i++)
{ x1 = halton(); if(x1 < 0. || x1 >= 1.) PR"%.12g\n", x1); }
exit(0);
*/

PR"ranmar1(1802,9373):\n");
rmarin1(&ij,&kl);
for(i = 0; i < 12; i++) PR"%.20g\n", ranmar1());
PR"\n");
PR"ranmar1(18,30001):\n");
ij = 18;
kl = 30001;
rmarin1(&ij,&kl);
for(i = 0; i < 12; i++) PR"%.20g\n", ranmar1());
/*exit(0);*/
/*
for(i = 0; i < 1000; i++) PR"%.12g %.12g\n", ranmar1(), ranmar1());
exit(0);

#ifdef ultrix
initstate(73121u, state, 256);
#else
initstate(73121, state, 256);
#endif
for(i = 0; i < 10000; i++)
  PR"%.12g %.12g\n", (double) random() / maxint, (double) random() / maxint);
exit(0);
*/

/* #define  PRINT_RAN */

init_halton(2);
init_halton(3);
init_halton(5);
init_halton(7);
#ifdef PRINT_RAN
x1 = halton();
for(i = 0; i < 20000; i++) {
	PR"%.12g %.12g\n", x1, x2 = halton());
	x1 = x2;
}
#else
/*for(i = 0; i < 100000000; i++) { if(i % 1000000 == 0) PR"%d\n", i); halton(); }*/
for(i = 0; i < 100000; i++)
	 { if(i % 10000 == 0) PR"%d  %.20g\n", i, halton()); i++; halton(); }
for(i = 0; i < 6; i++) PR"%.20g\n",  halton());
#endif
/*exit(0);*/


rmarin1(&ij,&kl);
#ifdef PRINT_RAN
x1 = ranmar1();
for(i = 0; i < 20000; i++) { PR"%.12g %.12g\n", x1, x2 = ranmar1()); x1 = x2; }
#else
for(i = 0; i < 20000; i++) ranmar1();
for(i = 0; i < 6; i++) PR"%8.3lf\n", ranmar1() * 4096 * 4096); 
#endif
/*exit(0);*/


#ifdef ultrix
initstate(73121u, state, 256);
#else
initstate(73121, state, 256);
#endif
x1 = (double) random() / maxint;
/*for(i = 0; i < 20000; i++)*/
for(i = 0; i < 20; i++)
	 { PR"%.12g %.12g\n", x1, x2 = (double) random() / maxint); x1 = x2; }
/*exit(0);*/

#ifdef ultrix
srand(73121u);
#else
srand(73121);
#endif
PR"%.20g\n", maxint);
x1 = (double) rand() / maxrand;
/*for(i = 0; i < 20000; i++)*/
for(i = 0; i < 20; i++)
	 { PR"%.12g %.12g\n", x1, x2 = (double) rand() / maxrand); x1 = x2; }
/*exit(0);*/

x1 = erand48(ss2);
/*for(i = 0; i < 20000; i++)*/
for(i = 0; i < 20; i++)
	 { PR"%.12g %.12g\n", x1, x2 = erand48(ss2)); x1 = x2; }

exit(0);

/* randon-number generator testing ----------------------------  end ---  */


TESTa:  /* continued */

PR"\n");
if(U > 0. || ( PR"OR"), U < -5. )) PR"   True\n");
U = -20.;
if(U > 0. || ( PR"OR"), U < -5. )) PR"   True\n");
U = -2.;
if(U > 0. || ( PR"OR"), U < -5. )) PR"   True\n");
PR"\n");

PR DateAndTime()); PR "\n\n");
PR"NULL: (pointer)  %p, (integer) %d\n", NULL, NULL);
PR"ff is an uninitialized FILE pointer: (pointer)  %p, (integer) %d\n\n",
						 ff, ff);
fprintf(f,"f was initialized to stdout\n");
if(ff == NULL) fprintf(f,"ff == NULL\n\n"); else fprintf(f,"ff != NULL\n\n");

if(c[0] == '\0') fprintf(f,"\'\\0\' is printed between z and k: z%ck\n",c[0]); 

i = 5;
while(i-- > 0) PR"%d\n",i);
PR"%d\n",i);

x = a;

PR "Is *x  and  x[0] the same?:  %lf  %lf\n\n", *x, x[0]);


/* Test of mixing formatted and binary records in the same file: */

znovu:

/*
PE "Enter a number: ");
scanf("%lf",&b);
PR "%g\n", b);
*/

PE "Write, read, write/read or exit? (w/r/wr/e)\n");
scanf("%s",c);
if(c[0] == 'e' || c[0] == 'E') goto END;
PR"\no1 = %ld, o = %ld, offset = %ld\n", o1, o, offset);
if((c[0] == 'w' || c[0] == 'W') && c[1] == '\0')
{
   PR"WRITE:\n");
/*   f = fopen("binary","wb"); */
   f = fopen("binary","w");
   setbuf(f, (char *)NULL);
   fprintf(f, "%g\n", (d[0] + 0.23));
   o1 = ftell(f);
   for(i=0; i<5; i++)
#ifdef ultrix
	fwrite((void *)a, sizeof(double),2,f);
#else
	fwrite((char *)a, sizeof(double),2,f);
#endif
   offset = ftell(f);
   fprintf(f,"\n%g\n", (d[1] + .7));
   rewind(f);
   fprintf(f,"%g\n", (d[0] - 7.2314563534));
   fseek(f,o1,SEEK_SET);
#ifdef ultrix
   fwrite((void *)&a[2], sizeof(double),1,f);
#else
   fwrite((char *)&a[2], sizeof(double),1,f);
#endif
   PE"File created, see the content by selecting READ\n");
   fclose(f);
}
else if(c[0] == 'r' || c[0] == 'R')
{
   PR"READ:\n");
/*   f = fopen("binary","rb"); */
   if( (f = fopen("binary","r")) == NULL )
	 { PE"\nYou must start with WRITE!!!\n"); goto znovu; }
   fscanf(f,"%lf", &b);  PR "::%.25g\n",b);
/*   for(i=0; i<15; i++) { j = fread((void *)&b, sizeof(double),1,f);
		         PR "%ld  %.25g\n", j, b); } */
   fseek(f,o1,SEEK_SET);
#ifdef ultrix
   while( fread((void *)&b, sizeof(double),1,f) )   PR "%.25g\n",b);
#else
   while( fread((char *)&b, sizeof(double),1,f) )   PR "%.25g\n",b);
#endif
   fseek(f,offset,SEEK_SET);
   if( fscanf(f,"%lf", &b) ) PR"::%.25g\n",b);
			else PR"::formatted number at \'offset\' destroyed\n");
   fclose(f);
}
else
{
   PR"WRITE and READ:\n");
   PR "SEEK_SET, SEEK_CUR, SEEK_END: %d %d %d\n", SEEK_SET, SEEK_CUR, SEEK_END);
   a[1] += 100.0;
   o += 16L;
/*   f = fopen("binary","rb+"); */
   if( (f = fopen("binary","r+")) == NULL )
	 { PE"\nYou must start with WRITE!!!\n"); goto znovu; }
   fseek(f,o1 + 8L,SEEK_CUR);
#ifdef ultrix
   fwrite((void *)d, sizeof(double),4,f);
#else
   fwrite((char *)d, sizeof(double),4,f);
#endif
/*   fseek(f,o,SEEK_END); */
   fseek(f,offset + o, SEEK_SET);
#ifdef ultrix
   fwrite((void *)&a[1], sizeof(double),2,f);
#else
   fwrite((char *)&a[1], sizeof(double),2,f);
#endif
   rewind(f);
   fseek(f,o1 + 8L,SEEK_CUR);
#ifdef ultrix
   while( fread((void *)&b, sizeof(double),1,f) )   PR "%.25g\n",b);
#else
   while( fread((char *)&b, sizeof(double),1,f) )   PR "%.25g\n",b);
#endif
   fclose(f);
}
goto znovu;

END:
PR"\n\nsize of int = %ld\n", sizeof(int));
PR"size of long = %ld\n", sizeof(long));
PR"size of short = %ld\n", sizeof(short));
PR"size of unsigned int = %ld\n", sizeof(unsigned int));
PR"size of unsigned long = %ld\n", sizeof(unsigned long));
PR"size of unsigned short = %ld\n", sizeof(unsigned short));
PR"size of float = %ld\n", sizeof(float));
PR"size of double = %ld\n", sizeof(double));
#ifdef ultrix
PR"size of long double = %ld\n", sizeof(long double));
#endif
PR"size of char = %ld\n", sizeof(char));
PR"size of unsigned char = %ld\n", sizeof(unsigned char));
#ifdef ultrix
PR"size of signed char = %ld\n", sizeof(signed char));
#endif
PR"\n");
PR"size of pointer to int = %ld\n", sizeof(int *));
PR"size of pointer to long = %ld\n", sizeof(long *));
PR"size of pointer to short = %ld\n", sizeof(short *));
PR"size of pointer to unsigned int = %ld\n", sizeof(unsigned int *));
PR"size of pointer to unsigned long = %ld\n", sizeof(unsigned long *));
PR"size of pointer to unsigned short = %ld\n", sizeof(unsigned short *));
PR"size of pointer to float = %ld\n", sizeof(float *));
PR"size of pointer to double = %ld\n", sizeof(double *));
#ifdef ultrix
PR"size of pointer to long double = %ld\n", sizeof(long double *));
#endif
PR"size of pointer to char = %ld\n", sizeof(char *));
PR"size of pointer to unsigned char = %ld\n", sizeof(unsigned char *));
#ifdef ultrix
PR"size of pointer to signed char = %ld\n", sizeof(signed char *));
#endif

/** PR"size of void = %ld\n", sizeof(void)); Unknown size!!!! **/

(void)unlink("binary");
exit();


TESTc:

{  long cycle = 0, ccle;

   f = fopen("binary","w");
   setbuf(f, (char *)NULL);
   for(i=0; i<6001; i++) {
#ifdef ultrix
	fwrite((void *)&cycle, sizeof(long),1,f);
#else
	fwrite((char *)&cycle, sizeof(long),1,f);
#endif
	cycle += 20000;
   }
   cycle -= 20000;
   PR"File \'binary\' created; cycle = %d\n", cycle);
   fclose(f);

   if( (f = fopen("binary","r")) == NULL )
         { PE"\nThis shouldn\'t happen!!!\n"); exit(-1); }
   i = 0;
#ifdef ultrix
   while( fread((void *)&ccle, sizeof(long),1,f) )
#else
   while( fread((char *)&ccle, sizeof(long),1,f) )
#endif
    { if(i * 20000 - ccle)
	 PR "i = %d,  i * 20000 = %d,  ccle = %d\n", i, i * 20000, ccle);
      i++;
    }
   (void)unlink("binary");
   PR"File \'binary\' read and deleted; ccle = %d\n", ccle);
   exit();
}

}
