/* ranmar.f -- translated by f2c (version of 17 June 1991  16:43:01).
   You must link the resulting object file with the libraries:
	-lf2c -lm -lc   (in that order)
*/

#include "/usr/local/f2c/src/f2c.h"

/* Common Block Declarations */

struct raset1_1_ {
    real u[97], c, cd, cm;
    integer i97, j97;
    logical test;
};

#define raset1_1 (*(struct raset1_1_ *) &raset1_)

/* Initialized data */

struct {
    integer fill_1[102];
    logical e_2;
    real e_3;
    } raset1_ = { {0}, FALSE_, (float)0. };


/* Table of constant values */

static integer c__1 = 1;

/* Subroutine */ int rmarin_(ij, kl)
integer *ij, *kl;
{
    /* Builtin functions */
    integer s_wsfe(), do_fio(), e_wsfe();
    /* Subroutine */ int s_stop();

    /* Local variables */
    static integer i, j, k, l, m;
    static real s, t;
    static integer ii, jj;

    /* Fortran I/O blocks */
    static cilist io___1 = { 0, 6, 0, "(A)", 0 };
    static cilist io___2 = { 0, 6, 0, "(A)", 0 };


/*This is the initialization routine for the random number generator RANMA
R()*/
/* NOTE: The seed variables can have values between:    0 <= IJ <= 31328 
*/
/*                                                      0 <= KL <= 30081 
*/
/*The random number sequences created by these two seeds are of sufficient
*/
/* length to complete an entire calculation with. For example, if sveral 
*/
/*different groups are working on different parts of the same calculation,
*/
/*each group could be assigned its own IJ seed. This would leave each grou
p*/
/* with 30000 choices for the second seed. That is to say, this random */
/* number generator can create 900 million different subsequences -- with 
*/
/* each subsequence having a length of approximately 10^30. */

/* Use IJ = 1802 & KL = 9373 to test the random number generator. The */
/* subroutine RANMAR should be used to generate 20000 random numbers. */
/*Then display the next six random numbers generated multiplied by 4096*40
96*/
/* If the random number generator is working properly, the random numbers 
*/
/* should be: */
/*           6533892.0  14220222.0  7275067.0 */
/*           6172232.0  8354498.0   10633180.0 */
    if (*ij < 0 || *ij > 31328 || *kl < 0 || *kl > 30081) {
	s_wsfe(&io___1);
	do_fio(&c__1, " The first random number seed must have a value betwe\
en 0 and 31328", 67L);
	e_wsfe();
	s_wsfe(&io___2);
	do_fio(&c__1, " The second seed must have a value between 0 and 30081"
		, 54L);
	e_wsfe();
	s_stop("trouble in rmarin", 17L);
    }
    i = *ij / 177 % 177 + 2;
    j = *ij % 177 + 2;
    k = *kl / 169 % 178 + 1;
    l = *kl % 169;
    for (ii = 1; ii <= 97; ++ii) {
	s = (float)0.;
	t = (float).5;
	for (jj = 1; jj <= 24; ++jj) {
	    m = i * j % 179 * k % 179;
	    i = j;
	    j = k;
	    k = m;
	    l = (l * 53 + 1) % 169;
	    if (l * m % 64 >= 32) {
		s += t;
	    }
	    t *= (float).5;
/* L3: */
	}
	raset1_1.u[ii - 1] = s;
/* L2: */
    }
    raset1_1.c = (float).021602869033813477;
    raset1_1.cd = (float).45623308420181274;
    raset1_1.cm = (float).99999982118606567;
    raset1_1.i97 = 97;
    raset1_1.j97 = 33;
    raset1_1.test = TRUE_;
    return 0;
} /* rmarin_ */

doublereal ranmar_()
{
    /* System generated locals */
    real ret_val;

    /* Builtin functions */
    integer s_wsfe(), do_fio(), e_wsfe();
    /* Subroutine */ int s_stop();

    /* Local variables */
    static real uni;

    /* Fortran I/O blocks */
    static cilist io___12 = { 0, 6, 0, "(A)", 0 };


/* This is the random number generator proposed by George Marsaglia in */
/* Florida State University Report: FSU-SCRI-87-50 */
/*It was slightly modified by F. James to produce an array of pseudorandom
*/
/* numbers. */
    if (! raset1_1.test) {
	s_wsfe(&io___12);
	do_fio(&c__1, " Call the init routine (RMARIN) before calling RANMAR",
		 53L);
	e_wsfe();
	s_stop("trouble in ranmar", 17L);
    }
    uni = raset1_1.u[raset1_1.i97 - 1] - raset1_1.u[raset1_1.j97 - 1];
    if (uni < (float)0.) {
	uni += (float)1.;
    }
    raset1_1.u[raset1_1.i97 - 1] = uni;
    --raset1_1.i97;
    if (raset1_1.i97 == 0) {
	raset1_1.i97 = 97;
    }
    --raset1_1.j97;
    if (raset1_1.j97 == 0) {
	raset1_1.j97 = 97;
    }
    raset1_1.c -= raset1_1.cd;
    if (raset1_1.c < (float)0.) {
	raset1_1.c += raset1_1.cm;
    }
    uni -= raset1_1.c;
    if (uni < (float)0.) {
	uni += (float)1.;
    }
    ret_val = uni;
    return ret_val;
} /* ranmar_ */

